/*
 * TsrServlet.java - This servlet keeps updating the cache
 * Copyright (C) 2000 Balaji Srinivasan
 * sbalaji@email.com
 * http://www.sbalaji.net
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
 
 
import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;


public class TsrServlet extends HttpServlet
{

	public TsrServlet()
	{
		TsrThread t = new TsrThread();
		KeepAlive k = new KeepAlive();
	
	}


	public void doGet (HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException
	{
		TsrThread t = new TsrThread();
		KeepAlive k = new KeepAlive();

	}

}


class KeepAlive implements Runnable
{

	Thread t;

	//this is to stop multiple instances of thuis servlet running simultaneously.
	static boolean bStarted = false;

	KeepAlive()
	{
		if (bStarted)
		{
			System.out.println("KeepAlive already running.");
			return;
		}
		System.out.println("Starting KeepAlive...");
		
		t = new Thread(this);
		t.start();
		System.out.println("KeepAlive Started.");

		bStarted = true;
	}	

	public void run()
	{
		while(true)
		{
			Date d = new Date();
			//System.out.println("Typing to KeepAlive @ " + d.toString());
			//do something		

			//String cData = Utility.getRemotePageData("http://localhost/index.htm");
			String cData = Utility.getRemotePageData("http://www.webappcabaret.com/balaji/dummypage.jsp");

			//System.out.println(cData);

			//System.out.println("Kept Alive!");

	
			Thread.yield();
			

			try
			{
				//30 mins = 1800000				
				//15 mins = 900000
				//Thread.sleep(900000);
				Thread.sleep(1000*30);
			}
			catch (InterruptedException ex)
			{
				//Do nothing
				System.out.println(ex);	
			}

		}
	}
}



class TsrThread implements Runnable
{

	Thread t;

	//this is to stop multiple instances of thuis servlet running simultaneously.
	static boolean bStarted = false;

	TsrThread()
	{
		if (bStarted)
		{
			System.out.println("TsrThread already running.");
			return;
		}
		System.out.println("Starting TsrThread...");
		
		t = new Thread(this);
		t.start();
		System.out.println("TsrThread Started.");

		bStarted = true;
	}	

	public void run()
	{
		while(true)
		{
			System.out.println("Checking for updates...");
			//do something		

			WebNews.writeTimesOfIndiaHeadlines("timesofindia.htm");

			Thread.yield();
			

			try
			{
				//30 mins = 1800000				
				//15 mins = 900000
				Thread.sleep(1000*60*60); // 1 Hour
				//Thread.sleep(1000*15);
			}
			catch (InterruptedException ex)
			{
				//Do nothing
				System.out.println(ex);	
			}

		}
	}
}